unit umain;

{$mode objfpc}{$H+}

interface

uses
  udata, Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, Grids;

type

  { TForm1 }

  TForm1 = class(TForm)
    Grid: TStringGrid;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure GridClick(Sender: TObject);
    procedure GridDrawCell(Sender: TObject; aCol, aRow: Integer; aRect: TRect;
      aState: TGridDrawState);
  private
    { private declarations }
    Regel: TRegel;
  public
    { public declarations }
  end; 

var
  Form1: TForm1; 

const
  MonthNames: array[1..12] of string = (
    'Januar',
    'Februar',
    'März',
    'April',
    'Mai',
    'Juni',
    'Juli',
    'August',
    'September',
    'Oktober',
    'November',
    'Dezember'
  );
  // Farben für keine Regel und hat Regel
  Colors: array[boolean] of TColor = (clWindow, clRed);

implementation

{$R *.lfm}

uses
  uedit;

{ TForm1 }

procedure TForm1.FormCreate(Sender: TObject);
var
  r: integer;
begin
  Regel := TRegel.Create;
  Grid.Cells[0, 0] := IntToStr(Regel.Year);
  for r := 1 to 12 do begin
    Grid.Cells[0, r] := MonthNames[r];
  end;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  Regel.Free;
end;

procedure TForm1.GridClick(Sender: TObject);
  procedure Item2Form(Item: TItem);
  begin
    Form2.HasRegel.Checked := Item.HasRegel;
    Form2.Staerke.ItemIndex := Form2.Staerke.Items.IndexOf(Item.Staerke);
    Form2.Schmerz.ItemIndex := Form2.Schmerz.Items.IndexOf(Item.Schmerz);
    Form2.Medizin.Text := Item.Medizin;
    Form2.Dosis.Text := Item.Dosis;
  end;
  procedure Form2Item(var Item: TItem);
  begin
    Item.HasRegel := Form2.HasRegel.Checked;
    Item.Staerke := Form2.Staerke.Items[Form2.Staerke.ItemIndex];
    Item.Schmerz := Form2.Schmerz.Items[Form2.Schmerz.ItemIndex];
    Item.Medizin := Form2.Medizin.Text;
    Item.Dosis := Form2.Dosis.Text;
  end;

var
  sg: TStringGrid;
  xy: TPoint;
  Item: TItem;
begin
  sg := TStringGrid(Sender);
  if (sg.Col >= sg.FixedCols) and (sg.Row >= sg.FixedRows) then begin
    xy := Point(sg.Col, sg.Row);
    Item := Regel.Item[xy];
    // Alle relevanten Felder im EingabeDialog setzen
    Item2Form(Item);
    // Formular initialisieren
    Form2.Pages.ActivePageIndex := 0;
    // EingabeDialog aufrufen
    Form2.ShowModal;
    if Form2.Status = mrOk then begin // Ok geklickt
      Form2Item(Item);
      Regel.Item[xy] := Item;
      // Neuzeichnen des Grid veranlassen
      sg.Invalidate;
    end;
  end;
end;

procedure TForm1.GridDrawCell(Sender: TObject; aCol, aRow: Integer;
  aRect: TRect; aState: TGridDrawState);
begin
  if (aCol < Grid.FixedCols) or (aRow < Grid.FixedRows) then begin
    // Fixe Zellen
    Grid.Canvas.Brush.Color := Grid.FixedColor;
  end else begin
    if aCol <= Regel.Lastday(aRow) then
      Grid.Canvas.Brush.Color := Colors[Regel.HasRegel[Point(aCol, aRow)]]
    else Grid.Canvas.Brush.Color := clBtnFace; // ungültige Tage
    Grid.Canvas.FillRect(aRect);
    Grid.Canvas.TextRect(aRect, aRect.Left + 2, aRect.Top + 2, Grid.Cells[aCol, aRow]);
  end;
end;

end.

